#include <bits/stdc++.h>

using namespace std;

#define MOD 998244353

int main()
{
    long long N, M;
    cin >> N >> M;
    long long B[M+1];
    for(int i = 1; i < M + 1; i++){
        cin >> B[i];
    }
    long long A[N + 1];
    for(int i = 1; i < N + 1; i++){
        A[i] = i;
    }
   for(int i = 0; i <= N - M; i++){
        for(int j = 1; j <= M; j++){
            A[i + B[j]] = A[i + j];
        }
   }
   long long c;
   cin >> c;
   long long suma = 0;
   for(int i = 1; i <= N; i++){
        long long c1 = (long long)pow(c,i);
        suma += c1 * A[i];
        suma %= MOD;
   }
   cout << suma;
   return 0;
}